//----------------------------------------------------------
#ifndef FrmMatlH
#define FrmMatlH
//----------------------------------------------------------
#include <d3drmwin.h>
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Dialogs.hpp>
//----------------------------------------------------------
class TMaterialForm : public TForm
{
__published:  // IDE-managed Components
  TGroupBox *gbEmissive;
  TGroupBox *gbSpecular;
  TTrackBar *tbEmR;
  TLabel *laEmR;
  TLabel *laEmRed;
  TShape *EmissiveShape;
  TLabel *laEmG;
  TLabel *laEmB;
  TTrackBar *tbEmG;
  TTrackBar *tbEmB;
  TTrackBar *tbSpR;
  TTrackBar *tbSpG;
  TTrackBar *tbSpB;
  TLabel *laSpR;
  TLabel *laSpG;
  TLabel *laSpB;
  TShape *SpecularShape;
  TLabel *laEmGreen;
  TLabel *laEmBlue;
  TLabel *laSpRed;
  TLabel *laSpGreen;
  TLabel *laSpBlue;
  TLabel *laPower;
  TEdit *edPower;
  TLabel *laMatMode;
  TComboBox *MatModeCombo;
  TButton *btnNew;
  TBevel *Bevel1;
  TBevel *Bevel2;
  TColorDialog *ColorDlg;
  void __fastcall MaterialChanged(TObject *Sender);
  void __fastcall edPowerKeyPress(TObject *Sender, char &Key);
  void __fastcall FormActivate(TObject *Sender);
  void __fastcall btnNewClick(TObject *Sender);
  void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
  TShiftState Shift);
  void __fastcall MatModeComboClick(TObject *Sender);
  void __fastcall EmissiveShapeMouseDown(TObject *Sender,
  TMouseButton Button, TShiftState Shift, int X, int Y);
  void __fastcall SpecularShapeMouseDown(TObject *Sender,
  TMouseButton Button, TShiftState Shift, int X, int Y);
private:    // User declarations
  void* FObject;
  LPDIRECT3DRMMATERIAL IRMMaterial;
  D3DVALUE EmR, EmG, EmB, Power, SpR, SpG, SpB;
  bool IsReading;
  void __fastcall EnableControls(bool enable);
public:     // User declarations
  __fastcall TMaterialForm(TComponent* Owner);
  __fastcall ~TMaterialForm();
  void __fastcall SetNone();
  void __fastcall Manage(void* object);
  void __fastcall GetMaterialData();
};
//----------------------------------------------------------
extern TMaterialForm *MaterialForm;
//----------------------------------------------------------
#endif
